###### Abstract

Let be a centrally symmetric convex polygon of and be the distance between two points in the normed plane whose unit ball is . For a set of points (terminals) in , a -Manhattan network on is a network with the property that its edges are parallel to the directions of and for every pair of terminals and , the network contains a shortest -path between them, i.e., a path of length A minimum -Manhattan network on is a -Manhattan network of minimum possible length. The problem of finding minimum -Manhattan networks has been introduced by Gudmundsson, Levcopoulos, and Narasimhan (APPROX’99) in the case when the unit ball is a square (and hence the distance is the or the -distance between and ) and it has been shown recently by Chin, Guo, and Sun [6] to be strongly NP-complete. Several approximation algorithms (with factors 8,4,3, and 2) for the minimum Manhattan problem are known. In this paper, we propose a factor 2.5 approximation algorithm for the minimum -Manhattan network problem. The algorithm employs a simplified version of the strip-staircase decomposition proposed in our paper [5] and subsequently used in other factor 2 approximation algorithms for the minimum Manhattan problem.

page1 \ae@guills

Minimum Manhattan network problem in normed planes

with polygonal balls: a factor 2.5 approximation algorithm

N. Catusse, V. Chepoi, K. Nouioua, and Y. Vaxès

Laboratoire d’Informatique Fondamentale de Marseille,

[0.1cm] Faculté des Sciences de Luminy, Aix-Marseille Université,

[0.1cm] F-13288 Marseille Cedex 9, France

[0.1cm] {catusse,chepoi,nouioua,vaxes}@lif.univ-mrs.fr

Keywords. Normed plane, distance, geometric network design, Manhattan network, approximation algorithms.

## 1 Introduction

### 1.1 Normed planes

Given a compact, centrally symmetric, convex set in the plane one can define a norm by setting where and is a unit vector belonging to the boundary of We can then define a metric on by setting The resulting metric space is called a normed (or Minkowski) plane with unit disk (gauge) [2, 24]. In this paper, we consider normed planes in which the unit ball is a centrally symmetric convex polygon (i.e., a zonotope) of We denote by the vertices of (in counterclockwise order around the circle) as well as the unit vectors that define these vertices. By central symmetry of for A legal -segment of is a segment lying on a line parallel to the line passing via and A legal path between two points of is any path connecting and in which all edges are legal segments. The length of is the sum of lengths of its edges. A shortest -path between and is a legal -path of minimum length. The best known example of normed planes with polygonal unit balls is the -plane (also called the rectilinear plane) with norm The unit ball of the -plane is a square whose two diagonals lie on the -axis and -axis, respectively. The -distance between two points and is The legal paths of the rectilinear plane are the paths consisting of horizontal and vertical segments, i.e., rectilinear paths. Another important particular case of polygonal norms is that of -norms (alias uniform norms) [4, 3] for which the unit ball is a regular polygon.

### 1.2 Minimum Manhattan and -Manhattan network problems

A rectilinear network in consists of a finite set of points and horizontal and vertical segments connecting pairs of points of The length of is the sum of lengths of its edges. Given a finite set of points in the plane, a Manhattan network [15] on is a rectilinear network such that and for every pair of points in the network contains a shortest rectilinear path between them. A minimum Manhattan network on is a Manhattan network of minimum possible length and the Minimum Manhattan Network problem (MMN problem) is to find such a network.

More generally, given a zonotope a -network consists of a finite set of points and legal segments connecting pairs of points of (the edges of ). The length of is the sum of lengths of its edges. Given a set of points (called terminals), a -Manhattan network on is a -network such that and for every pair of terminals in the network contains a shortest -path between them (see Fig. 2). A minimum -Manhattan network on is a -Manhattan network of minimum possible length and the Minimum -Manhattan Network problem (-MMN problem) is to find such a network. Fig. 3 illustrates the evolution of a minimum -Manhattan network defined on the same set of terminals when the number of directions in the unit ball is increasing (the directions of the unit ball are indicated at the upper left corner of each figure).

### 1.3 Known results

The minimum Manhattan network problem has been introduced by Gudmundsson, Levcopoulos, and Narasimhan [15]. Gudmundsson et al. [15] proposed an -time 4-approximation algorithm, and an -time 8-approximation algorithm. They also conjectured that there exists a 2-approximation algorithm for this problem and asked if this problem is NP-complete. Quite recently, Chin, Guo, and Sun [6] solved this last open question from [15] and established that indeed the minimum Manhattan network problem is strongly NP-complete. Kato, Imai, and Asano [17] presented a 2-approximation algorithm, however, their correctness proof is incomplete (see [1]). Following [17], Benkert, Wolff, Shirabe, and Widmann [1] described an -time 3-approximation algorithm and presented a mixed-integer programming formulation of the MMN problem. Nouioua [20] and later Fuchs and Schulze [12] presented two simple -time 3-approximation algorithms. The first correct 2-approximation algorithm (thus solving the first open question from [15]) was presented by Chepoi, Nouioua, and Vaxès [5]. The algorithm is based on a strip-staircase decomposition of the problem and uses a rounding method applied to the optimal solution of the flow based linear program described in [1]. In his PhD thesis, Nouioua [20] described a -time 2-approximation algorithm based on the primal-dual method from linear programming and the strip-staircase decomposition. In 2008, Guo, Sun, and Zhu [13, 14] presented two combinatorial factor 2 approximation algorithms, one with complexity and another with complexity (see also the PhD thesis [22] of Schulze for yet another -time 2-approximation algorithm). Finally, Seibert and Unger [21] announced a 1.5-approximation algorithm, however the conference format of their paper does not permit to understand the description of the algorithm and to check its claimed performance guarantee (a counterexample that an important intermediate step of their algorithm is incorrect was given in [12, 22]). Quite surprisingly, despite a considerable number of prior work on minimum Manhattan network problem, no previous paper, to our knowledge, consider its generalization to normed planes.

Gudmundsson et al. [15] introduced the minimum Manhattan networks in connection with the construction of sparse geometric spanners. Given a set of points in a normed plane and a real number , a geometric network is a -spanner for if for each pair of points there exists a -path in of length at most times the distance between and In the Euclidian plane and more generally, for normed planes with round balls, the line segment is the unique shortest path between two endpoints, and therefore the unique -spanner of is the complete graph on On the other hand, if the unit ball of the norm is a polygon, the points are connected by several shortest -paths, therefore the problem of finding the sparsest -spanner becomes non trivial. In this connection, minimum -Manhattan networks are precisely the optimal -spanners. Sparse geometric spanners have applications in VLSI circuit design, network design, distributed algorithms and other areas, see for example the survey of [10] and the book [18]. Lam, Alexandersson, and Pachter [19] suggested to use minimum Manhattan networks to design efficient search spaces for pair hidden Markov model (PHMM) alignment algorithms.

Algorithms for solving different distance problems in normed spaces with polygonal and polyhedral balls were proposed by Widmayer, Wu, and Wang [25] (for more references and a systematic study of such problems, see the book by Fink and Wood [11]). There is also an extensive bibliography on facility location problems in normed spaces with polyhedral balls, see for example [9, 23]. Finally, the minimum Steiner tree problem in the normed planes was a subject of intensive investigations, both from structural and algorithmic points of view; [4, 3, 8] is just a short sample of papers on the subject.

## 2 Preliminaries

### 2.1 Definitions, notations, auxiliary results

We continue by setting some basic definitions, notations, and known results. Let be a zonotope of with vertices having its center of symmetry at the origin of coordinates (see Fig. 4 for an example). The segment is a side of . We will call the line passing via the points and an extremal line of . Two consecutive extremal lines and defines two opposite elementary -cones and containing the sides and respectively. We extend this terminology, and call elementary -cones with apex the cones and obtained by translating the cones and by the vector We will call a pair of consecutive lines a direction of the normed plane. Denote by the ball of radius centered at the point

Let be the interval between and The inclusion holds for all normed spaces. If is round, then i.e., the shortest path between and is unique. Otherwise, may host a continuous set of shortest paths. The intervals in a normed plane (and, more generally, in a normed space) can be constructed in the following pretty way, described, for example, in the book [2]. If is a legal segment, then is the unique shortest path between and whence Otherwise, set Let be the side of the ball containing the point and let be the side of the ball containing the point . Notice that these sides are well-defined, otherwise is a vertex of and pq is a legal segment. The segments and are parallel, thus say and Then is the intersection of the elementary cones and (see Fig. 4 for an illustration):

###### Lemma 2.1

[2]

An immediate consequence of this result is the following characterization of shortest -paths between two points and .

###### Lemma 2.2

If is a legal segment, then is the unique shortest -path. Otherwise, if then any shortest -path between and has only -segments and -segments as edges. Moreover, is a shortest -path if and only if it is monotone with respect to and i.e., the intersection of with any line parallel to the lines is empty, a point, or a (legal) segment.

Proof. The first statement immediately follows from Lemma 2.1. Suppose that is not a legal segment and Let be the first edge on a shortest path from to which is neither a -segment nor a -segment. Since the point belongs to the cone and the point belongs to the cone whence Obviously, the point belongs to However, by the choice of the segment and the fact that and are consecutive lines that forms a direction, the point cannot belong a contradiction. This shows that any shortest legal path between and has only - and -segments as edges. Additionally, the intersection of with any line parallel to or is empty, a point, or a (legal) segment. Indeed, pick any two points in this intersection. Since the legal segment defined by these points is the unique shortest path between them, it must also belong to the intersection of with . Conversely, consider a monotone path between and namely suppose that the intersection of with any line parallel to the lines or is empty, a point, or a (legal) segment). We proceed by induction on the number of edges of The monotonicity of implies that lies entirely in the interval In particular, the neighbor of in belongs to The subpath of between and is monotone, therefore by induction assumption, is a shortest path between and Since is a legal segment and we immediately conclude that is also a shortest path between and

We continue with some notions and notations about the -MMN problem. Denote by OPT the length of a minimum -Manhattan network for a set of terminals . For a direction denote by the set of all pairs (or pairs of terminals ) such that any shortest -path between and uses only -segments and -segments. Equivalently, by Lemma 2.2, consists of all pairs of terminals which belong to two opposite elementary cones and with common apex. For each direction and the set of pairs we formulate an auxiliary problem which we call Minimum 1-Directional Manhattan Network problem (or 1-DMMN problem): find a network of minimum possible length such that every edge of is an -segment or an -segment and any pair of is connected in by a shortest -path. We denote its length by We continue by adapting to 1-DMMN the notion of a generating set introduced in [17] for MMN problem: a generating set for is a subset of with the property that a -Manhattan network containing shortest -paths for all pairs in is a 1-Directional Manhattan network for

### 2.2 Our approach

Let be a minimum -Manhattan network, i.e., a -Manhattan network of total length For each direction let be the set of -segments and -segments of The network is an admissible solution for 1-DMMN thus the length of is at least Any -segment of belongs to two one-directional networks and Vice-versa, if are admissible solutions for the 1-DMMN problems, since the network is a -Manhattan network. Moreover, if each is an -approximation for respective 1-DMMN problem, then the network is a -approximation for the minimum -Manhattan network problem. Therefore, to obtain a factor 2.5-approximation for -MMN, we need to provide a 1.25-approximation for the 1-DMMN problem. The remaining part of our paper describe such a combinatorial algorithm. The 1-DMMN problem is easier and less restricted than the -MMN problem because we have to connect with shortest paths only the pairs of terminals of the set corresponding to one direction , while in case of the MMN problem the set of all pairs is partitioned into two sets corresponding to the two directions of the -plane. For our purposes, we will adapt the strip-staircase decomposition of [5], by considering only the strips and the staircases which “are oriented in direction ”.

## 3 One-directional strips and staircases

In the next two sections, we assume that is a fixed but arbitrary direction of the normed plane. We recall the definitions of vertical and horizontal strips and staircases introduced in [5]. Then we consider only those of them which correspond to pairs of terminals from the set which we call one-directional strips and staircases. We formulate several properties of one-directional strips and staircases and we prove those of them which do not hold for usual strips and staircases.

Denote by and the set of all lines passing via the terminals of and parallel to the extremal lines and respectively. Let be the grid defined by the lines of and The following lemma can be proved in the same way as for rectilinear Steiner trees or Manhattan networks (quite surprisingly, this is not longer true for the -MMN problem: Fig. 2 presents an instance of -MMN for which the unique optimal solution does not belong to the grid ):

###### Lemma 3.1

There exists a minimum 1-Directional Manhattan Network for contained in the grid .

For two terminals set A pair defines a -strip if either (i) (degenerated strip) and are consecutive terminals belonging to the same line of or (ii) and belong to two consecutive lines of and the intersection of with any degenerated -strip is either empty or one of the terminals or see Fig. 6 of [5]The two -segments of are called the sides of The -strips and their sides are defined analogously (with respect to ). With some abuse of language, we will call the -strips horizontal and the -strips vertical. If a pair defining a horizontal or a vertical strip belongs to the set then we say that is a one-directional strip or a 1-strip, for short. Denote by the set of all pairs of defining one-directional strips.

###### Lemma 3.2

If and are two horizontal 1-strips or two vertical 1-strips, then if and if

Proof. From the definition follows that if and are both degenerated or one is degenerated and another one not, then they are either disjoint or intersect in a single terminal. If and are both non-degenerated and intersect, then from the definition immediately follows that the intersection is one point or a segment belonging to their sides. However, if and intersects in a segment, then one can easily see that at least one of and cannot be a 1-strip.

We say that a vertical 1-strip and a horizontal 1-strip (degenerated or not) form a crossing configuration if they intersect (and therefore cross each other).

###### Lemma 3.3

If and form a crossing configuration, then from the shortest -paths between and and between and one can derive shortest -paths connecting and respectively.

For a crossing configuration defined by the 1-strips denote by and the two opposite corners of the parallelogram such that the cones and do not intersect the interiors of and Additionally, suppose without loss of generality, that and belong to the cone while and belong to the cone Denote by the set of all terminals such that does not contain any terminal except Denote by the region of which is the union of the intervals and call this polygon an one-directional staircase or a 1-staircase, for short; see Fig. 5 and Figures 7,8 of [5] for an illustration. Note that is bounded by the 1-strips and and a legal path between and passing via all terminals of and consisting of -segments and -segments. The point is called the origin and and are called the basis of this staircase. Since for all and therefore For the same reason, there are no terminals of located in the regions and depicted in Fig. 5 ( is the region comprised between the leftmost side of the highest side of and the line of passing via the highest terminal of while is the region comprised between the rightmost side of the lowest side of and the line of passing via the rightmost terminal of ). Analogously one can define the set and the staircase with origin and basis and

###### Lemma 3.4

If a 1-strip intersects a 1-staircase and is different from the 1-strips and then is a single terminal.

Proof. If a 1-strip traverses a staircase , then one of the terminals must be located in one of the regions and which is impossible because Thus, if and intersect more than in one point, then they intersect in a segment which belongs to one side of and to the boundary of If say the 1-strip is horizontal, then necessarily is a part of the lowest side of and of the highest horizontal side of Let be the highest terminal of Then either belongs to and is different from contrary to the assumption that is a strip, or together with the lowest terminal of define a degenerated strip with belonging to contrary to the assumption that .

###### Lemma 3.5

Two 1-staircases either are disjoint or intersect only in common terminals.

Proof. From the definition of a staircase follows that the interiors of two staircases are disjoint (for a short formal proof of this see [5]). Therefore two staircases may intersect only on the boundary. In this case, the intersection is either a subset of terminals of both staircases or a single edge. In the second case, one of the two staircases necessarily is not a 1-staircase with respect to the chosen direction.

Let be the set of all pairs such that there exists a 1-staircase with belonging to the set The proof of the following essential result is identical to the proof of Lemma 3.2 of [5] and therefore is omitted.

###### Lemma 3.6

is a generating set for .

## 4 The algorithm

We continue with the description of our factor 1.25 approximation algorithm for 1-DMMN problem. Let and denote the pairs of defining horizontal and vertical 1-strips, respectively. Let and be the networks consisting of lower sides and respectively upper sides of the horizontal 1-strips of Analogously, let and be the networks consisting of rightmost sides and respectively leftmost sides of the vertical 1-strips of The algorithm completes optimally each of the networks and and from the set of four completions the algorithm returns the shortest one, which we will denote by (in this respect, our algorithm has some similarity with the approach of Benkert et al. [1]). We will describe now the optimal completion for the network the three other networks are completed in the same way (up to symmetry).

An optimal completion of is a subnetwork of extending () of smallest total length such that any pair of terminals of can be connected in by a shortest path. By Lemma 3.6, to solve the completion problem for , it suffices to (i) select a shortest path of between each pair defining a vertical 1-strip , (ii) for each horizontal 1-strip find a shortest path between and subject to the condition that the lowest side of is already available, (iii) for each staircase whose sides are and select shortest paths from the terminals of to the terminal subject to the condition that the lowest side of is already available. We need to minimize the total length of the resulting network over all vertical 1-strips and all 1-staircases. To solve the issue (ii) for a horizontal 1-strip we consider the rightmost 1-staircase having as a basis, set and solve for this staircase the issue (iii) for the extended set of terminals. For all other 1-staircases and having as a basis, we will solve only the issue (iii) for and respectively.

To deal with (iii), for each vertical 1-strip we pick each shortest path of between and include it in the current completion, and solve (iii) for all 1-staircases having as a vertical base and taking into account that is already present. We have to connect the terminals of by shortest paths of of least total length to the terminal subject to the condition that the union is already available; see Fig. 5. For a fixed path this task can be done by dynamic programming in time. For this, notice that in an optimal solution (a) either the highest terminal of is connected by a vertical segment to or (b) the lowest terminal of is connected by a horizontal segment to , or (c) contains two consecutive (in the staircase) terminals such that is connected to by a horizontal segment and is connected to by a vertical segment. In each of the three cases and subsequent recursive calls, we are lead to solve subproblems of the following type: given a set of consecutive terminals of the path and a horizontal segment connect to the terminals of by shortest paths of least total length if the union is available. We define by the optimal completion obtained by solving by dynamic programming those problems for all staircases having as a vertical basis (note that however ). For each vertical 1-strip the completion algorithm returns the partial completion of least total length, i.e, is the smallest completion of the form taken over all shortest paths running between and in Finally, let be the union of all over all vertical 1-strips and The pseudocode of the completion algorithm is presented below (the total complexity of this algorithm is ).

###### Lemma 4.1

The network returned by the algorithm Optimal completion is an optimal completion for

Proof. We described above how to compute for each 1-staircase a subset of edges of of minimum total length such that contains a shortest path of from each terminal of to This standard dynamical programming approach explores all possible solutions and therefore achieves optimality for this problem. Next, we assert that, for each vertical 1-strip the subset of edges computed by our algorithm, is an optimal completion of for the strip and the staircases having as vertical bases. Indeed, our algorithm considers every possible shortest path of between and Once the path is fixed, the subproblems related to distinct staircases become independent and can be solved optimally by dynamic programming. The problems arising from distinct vertical 1-strips are also disjoint and independent (according to Lemmas 3.4 and 3.5). Therefore the solution obtained by combining the optimal solutions of every vertical 1-strip is an optimal completion of

It remains to show that to obtain a completion satisfying the conditions (i),(ii), and (iii), it suffices for each horizontal 1-strip to add to the set of terminals of the rightmost staircase having as a basis and to solve (iii) for this extended set of terminals. Indeed, in any completion any shortest path between and necessarily makes a vertical switch either before arriving at the origin of or this path traverses the vertical basis of this staircase. Since the completion contains a shortest path connecting the terminals of the vertical basis of , combining these two paths, we can derive a shortest path between and which turns in As a result, we conclude that at least one shortest path between and passes via This shows that indeed it suffices to take into account the condition (ii) only for each rightmost staircase.

###### Lemma 4.2

The network is an admissible solution for the problem 1-DMMN

## 5 Approximation ratio and complexity

In this section, we will prove the following main result:

###### Theorem 5.1

The network is a factor 1.25 approximation for 1-DMMN problem for The network is a factor 2.5 approximation for the -MMN problem and can be constructed in time.

Proof of Theorem 5.1. First we prove the first assertion of the theorem. Let and Further, we suppose that Assume be an optimal 1-restricted Manhattan network for Let be a subnetwork of of minimum total length which completed with some vertical edges of contains a shortest path between each pair of terminals defining a horizontal 1-strip of Such exists because the network already satisfies this requirement. Further, we assume that

###### Lemma 5.2

Proof. By Lemma 3.2, two horizontal 1-strips either are disjoint or intersect only in common terminals, thus any horizontal 1-strip contributes to separately from other horizontal 1-strips. Since the terminals and defining are connected in by a shortest path consisting of two horizontal segments of total length equal to the length of a side of and a vertical switch between these segments, from the optimality choice of we conclude that the contribution of to is precisely the length of one of its sides.

###### Lemma 5.3

Proof. The proof follows from the assumption and the fact that and form a partition of

###### Lemma 5.4

Proof. Since by Lemma 5.2 and 5.3 we get The last inequality follows from (a consequence of Lemma 3.2) and the assumption

Now, we complete the proof of Theorem 5.1. Note that

The first inequality follows from the choice of as the shortest network among the four completions The second inequality follows from Lemma 4.1 and the fact that (and therefore ) is an admissible solution for the completion problem for Finally, the last inequality follows from Lemma 5.4 by noticing that and thus This concludes the proof of the first assertion of Theorem 5.1.

Let be a minimum -Manhattan network. For each direction let be the set of -segments and -segments of By Lemma 2.2 the network is an admissible solution for 1-DMMN problem, thus Any -segment of belongs to exactly two one-directional networks and we conclude that